
Table internet;
int rowCount;

String [] cat = new String[12];
String [] minen = new String[12];
String []  maxen= new String[12];


void setup() {
  size(900, 700);
  // Make a data table from a file that contains 
  // the coordinates of each state.
  internet = new Table("internet.tsv");
  // The row count will be used a lot, store it locally.
  rowCount = internet.getRowCount();
  for (int i = 0; i < rowCount; i++) {
    cat[i] = internet.getString(i, 0);  // column 1
    minen[i] = internet.getString(i, 1);  // column 2
    maxen[i] = internet.getString(i, 2);
  }
}

void draw() {
  background(255);
  //image(mapImage, 0, 0);

  // Drawing attributes for the ellipses   
  smooth();
  fill(192, 0, 0);
  noStroke();
  int y= 50;
  int Y= 45;
  // Loop through the rows of the locations file and draw the points  
  for (int i = 0; i < rowCount; i++) {
    text(cat[i], 50, y);
    text(minen[i], 200, y);
    text(maxen[i], 350, y);
    float ex = internet.getFloat(i, 1);  // column 1
    float ey = internet.getFloat(i, 2);  // column 2
    y+=50;
    Y+=45;
    ellipse(650, Y, ey, ex);
  }
}

class Table {
  int rowCount;
  String[][] data;
  
  
  Table(String filename) {
    String[] rows = loadStrings(filename);
    data = new String[rows.length][];
    
    for (int i = 0; i < rows.length; i++) {
      if (trim(rows[i]).length() == 0) {
        continue; // skip empty rows
      }
      if (rows[i].startsWith("#")) {
        continue;  // skip comment lines
      }
      
      // split the row on the tabs
      String[] pieces = split(rows[i], TAB);
      // copy to the table array
      data[rowCount] = pieces;
      rowCount++;
      
      // this could be done in one fell swoop via:
      //data[rowCount++] = split(rows[i], TAB);
    }
    // resize the 'data' array as necessary
    data = (String[][]) subset(data, 0, rowCount);
  }
  
  
  int getRowCount() {
    return rowCount;
  }
  
  
  // find a row by its name, returns -1 if no row found
  int getRowIndex(String name) {
    for (int i = 0; i < rowCount; i++) {
      if (data[i][0].equals(name)) {
        return i;
      }
    }
    println("No row named '" + name + "' was found");
    return -1;
  }
  
  
  String getRowName(int row) {
    return getString(row, 0);
  }


  String getString(int rowIndex, int column) {
    return data[rowIndex][column];
  }

  
  String getString(String rowName, int column) {
    return getString(getRowIndex(rowName), column);
  }

  
  int getInt(String rowName, int column) {
    return parseInt(getString(rowName, column));
  }

  
  int getInt(int rowIndex, int column) {
    return parseInt(getString(rowIndex, column));
  }

  
  float getFloat(String rowName, int column) {
    return parseFloat(getString(rowName, column));
  }

  
  float getFloat(int rowIndex, int column) {
    return parseFloat(getString(rowIndex, column));
  }
  
  
  void setRowName(int row, String what) {
    data[row][0] = what;
  }


  void setString(int rowIndex, int column, String what) {
    data[rowIndex][column] = what;
  }

  
  void setString(String rowName, int column, String what) {
    int rowIndex = getRowIndex(rowName);
    data[rowIndex][column] = what;
  }

  
  void setInt(int rowIndex, int column, int what) {
    data[rowIndex][column] = str(what);
  }

  
  void setInt(String rowName, int column, int what) {
    int rowIndex = getRowIndex(rowName);
    data[rowIndex][column] = str(what);
  }

  
  void setFloat(int rowIndex, int column, float what) {
    data[rowIndex][column] = str(what);
  }


  void setFloat(String rowName, int column, float what) {
    int rowIndex = getRowIndex(rowName);
    data[rowIndex][column] = str(what);
  }  
}

